<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../.resources/report.css" type="text/css"/><link rel="shortcut icon" href="../.resources/report.gif" type="image/gif"/><title>Watcher.java</title><link rel="stylesheet" href="../.resources/prettify.css" type="text/css"/><script type="text/javascript" src="../.resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../.sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">testBundle</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper</a> &gt; <span class="el_source">Watcher.java</span></div><h1>Watcher.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper;

/**
 * This interface specifies the public interface an event handler class must
 * implement. A ZooKeeper client will get various events from the ZooKeeper
 * server it connects to. An application using such a client handles these
 * events by registering a callback object with the client. The callback object
 * is expected to be an instance of a class that implements Watcher interface.
 * 
 */
public interface Watcher {

    /**
     * This interface defines the possible states an Event may represent
     */
    public interface Event {
        /**
         * Enumeration of states the ZooKeeper may be at the event
         */
<span class="pc" id="L38">        public enum KeeperState {</span>
            /** Unused, this state is never generated by the server */
<span class="fc" id="L40">            @Deprecated</span>
            Unknown (-1),

            /** The client is in the disconnected state - it is not connected
             * to any server in the ensemble. */
<span class="fc" id="L45">            Disconnected (0),</span>

            /** Unused, this state is never generated by the server */
<span class="fc" id="L48">            @Deprecated</span>
            NoSyncConnected (1),

            /** The client is in the connected state - it is connected
             * to a server in the ensemble (one of the servers specified
             * in the host connection parameter during ZooKeeper client
             * creation). */
<span class="fc" id="L55">            SyncConnected (3),</span>

            /**
             * Auth failed state
             */
<span class="fc" id="L60">            AuthFailed (4),</span>

            /**
             * The client is connected to a read-only server, that is the
             * server which is not currently connected to the majority.
             * The only operations allowed after receiving this state is
             * read operations.
             * This state is generated for read-only clients only since
             * read/write clients aren't allowed to connect to r/o servers.
             */
<span class="fc" id="L70">            ConnectedReadOnly (5),</span>

            /**
              * SaslAuthenticated: used to notify clients that they are SASL-authenticated,
              * so that they can perform Zookeeper actions with their SASL-authorized permissions.
              */
<span class="fc" id="L76">            SaslAuthenticated(6),</span>

            /** The serving cluster has expired this session. The ZooKeeper
             * client connection (the session) is no longer valid. You must
             * create a new client connection (instantiate a new ZooKeeper
             * instance) if you with to access the ensemble. */
<span class="fc" id="L82">            Expired (-112);</span>

            private final int intValue;     // Integer representation of value
                                            // for sending over wire

<span class="fc" id="L87">            KeeperState(int intValue) {</span>
<span class="fc" id="L88">                this.intValue = intValue;</span>
<span class="fc" id="L89">            }</span>

            public int getIntValue() {
<span class="fc" id="L92">                return intValue;</span>
            }

            public static KeeperState fromInt(int intValue) {
<span class="pc bpc" id="L96" title="7 of 9 branches missed.">                switch(intValue) {</span>
<span class="nc" id="L97">                    case   -1: return KeeperState.Unknown;</span>
<span class="fc" id="L98">                    case    0: return KeeperState.Disconnected;</span>
<span class="nc" id="L99">                    case    1: return KeeperState.NoSyncConnected;</span>
<span class="nc" id="L100">                    case    3: return KeeperState.SyncConnected;</span>
<span class="nc" id="L101">                    case    4: return KeeperState.AuthFailed;</span>
<span class="nc" id="L102">                    case    5: return KeeperState.ConnectedReadOnly;</span>
<span class="nc" id="L103">                    case    6: return KeeperState.SaslAuthenticated;</span>
<span class="nc" id="L104">                    case -112: return KeeperState.Expired;</span>

                    default:
<span class="fc" id="L107">                        throw new RuntimeException(&quot;Invalid integer value for conversion to KeeperState&quot;);</span>
                }
            }
        }

        /**
         * Enumeration of types of events that may occur on the ZooKeeper
         */
<span class="pc" id="L115">        public enum EventType {</span>
<span class="fc" id="L116">            None (-1),</span>
<span class="fc" id="L117">            NodeCreated (1),</span>
<span class="fc" id="L118">            NodeDeleted (2),</span>
<span class="fc" id="L119">            NodeDataChanged (3),</span>
<span class="fc" id="L120">            NodeChildrenChanged (4);</span>

            private final int intValue;     // Integer representation of value
                                            // for sending over wire

<span class="fc" id="L125">            EventType(int intValue) {</span>
<span class="fc" id="L126">                this.intValue = intValue;</span>
<span class="fc" id="L127">            }</span>

            public int getIntValue() {
<span class="fc" id="L130">                return intValue;</span>
            }

            public static EventType fromInt(int intValue) {
<span class="pc bpc" id="L134" title="4 of 6 branches missed.">                switch(intValue) {</span>
<span class="nc" id="L135">                    case -1: return EventType.None;</span>
<span class="nc" id="L136">                    case  1: return EventType.NodeCreated;</span>
<span class="nc" id="L137">                    case  2: return EventType.NodeDeleted;</span>
<span class="nc" id="L138">                    case  3: return EventType.NodeDataChanged;</span>
<span class="fc" id="L139">                    case  4: return EventType.NodeChildrenChanged;</span>

                    default:
<span class="fc" id="L142">                        throw new RuntimeException(&quot;Invalid integer value for conversion to EventType&quot;);</span>
                }
            }           
        }
    }

    abstract public void process(WatchedEvent event);
}
</pre><div class="footer"><span class="right">Created with <a href="$jacoco.home.url$">JaCoCo</a> $qualified.bundle.version$</span></div></body></html>